#ifndef _COMPUTE_ENU_
#define _COMPUTE_ENU_

Eigen::Vector3d cart_to_enu(const Eigen::Vector3d& cart, const Eigen::Vector3d& ref) {
    const double X = cart(0);
    const double Y = cart(1);
    const double Z = cart(2);
    const double ref_phi = ref(0);
    const double ref_lambda = ref(1);
    const double ref_h = ref(2);
    const double E = -sin(ref_lambda) * X + cos(ref_lambda) * Y;
    const double N = -sin(ref_phi) * cos(ref_lambda) * X - sin(ref_phi) * sin(ref_lambda) * Y + cos(ref_phi) * Z;
    const double U = cos(ref_phi) * cos(ref_lambda) * X + cos(ref_phi) * sin(ref_lambda) * Y + sin(ref_phi) * Z;
    return Eigen::Vector3d(E, N, U);
}

#endif
